package com.zayac.changeurl.entity;

import cn.hutool.core.util.ReUtil;
import cn.hutool.core.util.StrUtil;
import com.zayac.changeurl.annotation.MsgAnnotation;
import com.zayac.changeurl.common.Constant;
import com.zayac.changeurl.enums.ErrorEnum;
import com.zayac.changeurl.exception.BizException;
import lombok.Data;

import java.lang.reflect.Field;

/**
 * @author zayac
 * @since 2023-09-09 1:05
 */
@Data
public class HthMsgEntity {
    @MsgAnnotation(startWith = "web")
    private String pc;
    @MsgAnnotation(startWith = "h5")
    private String h5;
    @MsgAnnotation(startWith = "全站APP")
    private String app;
    @MsgAnnotation(startWith = "体育APP")
    private String tyApp;

    public HthMsgEntity(String[] array) {
        for (Field field : this.getClass().getDeclaredFields()) {
            MsgAnnotation msgAnnotation = field.getAnnotation(MsgAnnotation.class);
            if (msgAnnotation != null) {
                // 获取注解的startWith属性值
                String startWith = msgAnnotation.startWith();
                String val = "";
                for (int i = 0; i < array.length; i++) {
                    //如果以开头字符开头并且字符长度大于startWith，认为在一行
                    if (array[i].startsWith(startWith) && StrUtil.cleanBlank(array[i]).length() > startWith.length()) {
                        val = ReUtil.getGroup1(Constant.URL_PATTERN, array[i]);
                    } else if (array[i].startsWith(startWith)) {
                        val = ReUtil.getGroup1(Constant.URL_PATTERN, array[i + 1]);
                    }
                }
                if (StrUtil.isBlank(val)) {
                    throw new BizException(ErrorEnum.MSG_ERROR);
                }
                field.setAccessible(true);
                try {
                    field.set(this, val);
                } catch (IllegalAccessException e) {
                    e.printStackTrace();
                }
            }
        }
    }
}
